[CmdletBinding(DefaultParametersetName="default")] 
param(
      [Parameter(Mandatory=$false,ParameterSetName="clear")]
      [switch]$Force,
      [Parameter(Mandatory=$false,ParameterSetName="set")]
      [switch]$SetPostponeFlag,
      [Parameter(Mandatory=$false,ParameterSetName="clear")]
      [switch]$ClearPostponeFlag
)

function write-logline{
  param(
      [Parameter(Mandatory=$true, Position=0)]
      [string]$logline,
      [Parameter(Mandatory=$true, Position=1)]
      [ValidateSet(
        "info", 
        "warning",
        "error"
      )]
      [string]$severity
  )
  switch($severity){
    "info" {
      $eventID = 30000
      $entryType = "Information"
    }
    "warning" {
      $eventID = 30001
      $entryType = "Warning"
    }
    "error" {
      $eventID = 30002
      $entryType = "Error"
    }
  }
  write-host "[$(get-date -Format "yyyy-MM-dd HH:mm")] $logline" -ForegroundColor Yellow
  write-eventlog -message "$scriptPath $logline" -LogName System -EntryType $entryType -EventID $eventID -source "Install-Windowsupdate"
}
$maintenanceWindowStartTime = get-date
$maintenanceWindowEndTime = $maintenanceWindowStartTime + $(New-TimeSpan  -Hours {{ windows_maintenance_window.duration }})

# Making sure the Source exists in the system log
New-EventLog -LogName System -Source "Install-Windowsupdate" -ErrorAction SilentlyContinue
$scriptPath = $MyInvocation.MyCommand.Path

# Used to postpone the updates untill the -ClearPostponeFlag is used
if($SetPostponeFlag){
  write-logline -logline "Postpone flag will be set (C:\postpone_updates). Updates will be postponed untill cleared" -severity Warning
  new-item -path "c:\postpone_updates" -itemtype File -force | out-null
  exit
}

# Exit if the postpone flag is found. Is -ClearPostponeFlag is used the flag will be cleared and the next run will be a normal run
if(test-path "c:\postpone_updates"){
  write-logline -logline "File c:\postpone_updates found. Updates will be postponed this week" -severity Warning
  if($ClearPostponeFlag){
    write-logline -logline "Postpone flag will be cleared. Next run will be normal" -severity Warning
    remove-item "c:\postpone_updates" -force
  }
  exit
}

# Search for updates. If -Force flag is used, install those updates and reboot if needed.
write-logline -logline  "Searching for new Windows Updates" -severity Info
$WindowsUpdates = Get-WUInstall -WindowsUpdate
if($WindowsUpdates.count -gt 0){
  $message = $WindowsUpdates | Select Title,Size | Format-List | out-string
  if($Force){
    write-logline -logline "Installing $($WindowsUpdates.count) updates $message" -severity Info
    Get-WUInstall -WindowsUpdate -Install -IgnoreReboot -AcceptAll | Out-Null
    write-logline -logline  "Finished installing $($WindowsUpdates.count) updates" -severity Info
  }
  else{
    write-logline -logline "Force flag was not used. No updates will be installed" -severity Info
  }
}

else{
    write-logline "No updates were found" -severity Info
}

if(Get-WURebootStatus -Silent){
  if($Force){
    $timeLeftInMaintenanceWindow = new-timespan -Start (get-date) -End $maintenanceWindowEndTime
    if($timeLeftInMaintenanceWindow -lt 0){
      write-logline -logline "Reboot pending state found, but maintenance Window has expired. No reboot has taken place" -severity Warning
    }
    else{
      write-logline -logline "Reboot pending state found. Restarting Windows in 1 minute" -severity Info
      Start-Process -FilePath C:\windows\System32\shutdown.exe -ArgumentList '/r /t 60 /c "Windows update scheduled reboot"'
    }
  }
  else{
    write-logline -logline "Force flag was not used. Computer will not be restarted. Reboot Status remains true" -severity Info
  }
}


